"
 COPYRIGHT (c) 1995 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

SocketAddress variableByteSubclass:#IPSocketAddress
	instanceVariableNames:'port'
	classVariableNames:''
	poolDictionaries:''
	category:'OS-Sockets'
!

!IPSocketAddress class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1995 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    Instances of IPSocketAddress represent tcp/ip-domain socket addresses.
    These consist of an ip address (4 bytes) and a port number.

    ST-80 compatibility class.
    This may be required when existing code has to be ported to ST/X;
    however, it may not be complete and more protocol may be added in the future.
    The code here was created when public domain code (Manchester) had to
    be ported to ST/X and missing classes/methods were encountered, and code added
    by reasoning 'what the original class could probably do there'.

    This is an additional goody class; therefore:

    THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTOR ``AS IS'' AND
    ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
    ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTOR BE LIABLE
    FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
    OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
    LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
    OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.
"
! !

!IPSocketAddress class methodsFor:'instance creation'!

new
    ^ self new:4


! !

!IPSocketAddress class methodsFor:'queries'!

hostAddressByName: hostName
    ^ Socket ipAddressOfHost:hostName

    "
     IPSocketAddress hostAddressByName:'clam' 
     IPSocketAddress hostAddressByName:'foobar' 
    "
!

hostNameByAddress: anAddress
    ^ Socket hostWithIpAddress:anAddress

    "
     |addr|

     addr := IPSocketAddress hostAddressByName:'porty'.
     IPSocketAddress hostNameByAddress:addr  
    "
!

servicePortByName:serviceName
    ^ Socket portOfService:serviceName

    "
     IPSocketAddress servicePortByName:'nntp' 
     IPSocketAddress servicePortByName:'time' 
    "
! !

!IPSocketAddress methodsFor:'accessing'!

hostAddress
    ^ (ByteArray new:4) replaceFrom:1 to:4 with:self startingAt:1

!

hostName:name port:portNr
    self 
        hostAddress:(Socket ipAddressOfHost:name)
        port:portNr

    "
     IPSocketAddress hostName:'exept' port:10
    "
!

port
    ^ port
!

port:aPortNr
    port := aPortNr
! !

!IPSocketAddress methodsFor:'printing & storing'!

printOn:aStream
    "append a user printed representation of the receiver to aStream.
     The format is suitable for a human - not meant to be read back."

    1 to:4 do:[:i | 
        (i between:2 and:4) ifTrue:[
            aStream nextPut:$.
        ].
        (self at:i) printOn:aStream
    ].
    port notNil ifTrue:[
        aStream nextPut:$:.
        port printOn:aStream.
    ].
! !

!IPSocketAddress methodsFor:'queries'!

address
    ^ self hostAddress
!

hostName
    ^ Socket hostWithIpAddress:self

    "
     (IPSocketAddress hostAddress:#[193 141 12 193] port:10) hostName
    "

    "Created: 2.11.1995 / 11:17:28 / cg"
!

portOrName
    ^ port
! !

!IPSocketAddress class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic2/IPSocketAddress.st,v 1.10 1999-09-21 00:27:23 cg Exp $'
! !
